#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <ctime>
#include <cassert>
#include <complex>
#include <string>
#include <cstring>
#include <chrono>
#include <random>
#include <bitset>
#include <array>
using namespace std;

#ifdef LOCAL
	#define eprintf(...) {fprintf(stderr, __VA_ARGS__);fflush(stderr);}
#else
	#define eprintf(...) 42
#endif

using ll = long long;
using ld = long double;
using uint = unsigned int;
using ull = unsigned long long;
template<typename T>
using pair2 = pair<T, T>;
using pii = pair<int, int>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
ll myRand(ll B) {
	return (ull)rng() % B;
}

#define pb push_back
#define mp make_pair
#define all(x) (x).begin(),(x).end()
#define fi first
#define se second

clock_t startTime;
double getCurrentTime() {
	return (double)(clock() - startTime) / CLOCKS_PER_SEC;
}

const ll T = 2520;
const int M = 12;
const int N = (int)2.1e6 + 7;
int n, m, k;
ll v, F;
pll lines[N];
vector<pll> walls[M];
vector<pll> pts;
int dp[2][N];
pli ord[M][N];
int id[N];
int fenv[N];

void setFenv(int p, int x) {
	for(; p < k; p |= p + 1)
		fenv[p] = min(fenv[p], x);
}
int getFenv(int r) {
	int res = N;
	for(; r >= 0; r = (r & (r + 1)) - 1)
		res = min(res, fenv[r]);
	return res;
}

int main()
{
	startTime = clock();
//	freopen("input.txt", "r", stdin);
//	freopen("output.txt", "w", stdout);

	scanf("%d%d%lld%lld", &n, &m, &F, &v);
	v *= T;
	F *= T;
	F -= (m + 1) * v;
	if (F < 0) {
		printf("-1\n");
		return 0;
	}
	while(n--) {
		ll l, r;
		int y;
		scanf("%lld%lld%d", &l, &r, &y);
		l *= T;
		r *= T;
		l -= y * v;
		r -= y * v;
		if (r <= 0 || l >= F) continue;
		walls[y].push_back(mp(l, r));
		if (l >= 0) pts.push_back(mp(l, (ll)y));
		if (r <= F) pts.push_back(mp(r, (ll)y));
	}
	pts.push_back(mp(0LL, 0LL));
	pts.push_back(mp(F, (ll)(m + 1)));
	sort(all(pts));
	pts.resize(unique(all(pts)) - pts.begin());
	n = 0;
	for (int i = 0; i < (int)pts.size(); i++) {
		ll x1 = pts[i].first, y1 = pts[i].second;
		lines[n++] = mp(0, x1);
		for (int j = i + 1; j < (int)pts.size(); j++) {
			ll x2 = pts[j].first, y2 = pts[j].second;
			if (x2 <= x1 || y2 <= y1) continue;
			ll k = (x2 - x1) / (y2 - y1);
			//assert(k * (y2 - y1) == x2 - x1);
			lines[n++] = mp(k, x1 - y1 * k);
		}
	}
	sort(lines, lines + n);
	n = unique(lines, lines + n) - lines;

	for (int i = 0; i < n; i++) {
		dp[0][i] = N;
		if (lines[i].second >= 0) dp[0][i] = 0;
	}
	for (int y = 0; y <= m + 1; y++) {
		sort(all(walls[y]));
		for (int i = 0; i < n; i++)
			ord[y][i] = mp(lines[i].first * y + lines[i].second, i);
		sort(ord[y], ord[y] + n);
	}
	for (int y = 0; y <= m; y++) {
		int q = 0;
		int l = 0;
		int w = N;
		while(l < n) {
			int r = l + 1;
			ll x = ord[y][l].first;
			while(r < n && x == ord[y][r].first) r++;
			while(q < (int)walls[y].size() && walls[y][q].second <= x) q++;
			if (q < (int)walls[y].size() && walls[y][q].first < x) {
				for (int i = l; i < r; i++) {
					dp[0][ord[y][i].second] = w + 2;
				}
			} else {
				int z = N;
				for (int i = l; i < r; i++)
					z = min(dp[0][ord[y][i].second], z);
				z = min(z, w + 1);
				for (int i = l; i < r; i++) {
					int v = ord[y][i].second;
					dp[0][v] = min(dp[0][v], z + 1);
				}
				w = min(w, z);
			}
			l = r;
		}
		for (int i = 0; i < n; i++)
			dp[1][i] = N;
		k = 0;
		for (int i = 0; i < n; i++) {
			if (i > 0 && ord[y + 1][i].first != ord[y + 1][i - 1].first) k++;
			id[ord[y + 1][i].second] = k;
		}
		k++;
		for (int i = 0; i < k; i++)
			fenv[i] = N;
		for (int i = n - 1; i >= 0; i--) {
			int v = ord[y][i].second;
			dp[1][v] = min(dp[1][v], getFenv(id[v]));
			setFenv(id[v], dp[0][v] + 1);
		}
		for (int i = 0; i < k; i++)
			fenv[i] = N;
		for (int i = 0; i < n; i++) {
			int v = ord[y][i].second;
			dp[1][v] = min(dp[1][v], getFenv(k - 1 - id[v]));
			setFenv(k - 1 - id[v], dp[0][v] + 1);
		}
		for (int i = 0; i < n; i++)
			dp[0][i] = min(dp[0][i], dp[1][i]);
	}
	int ans = N;
	for (int i = 0; i < n; i++)
		if (lines[i].first * (m + 1) + lines[i].second <= F)
			ans = min(ans, dp[0][i]);
	if (ans == N) ans = -1;
	printf("%d\n", ans);

	return 0;
}
