#define _USE_MATH_DEFINES
#include <bits/stdc++.h>
using namespace std;
typedef long long LL;
typedef unsigned long long ULL;
#define SZ(x) ((int)((x).size()))
#define all(x) (x).begin(), (x).end()

// Returns the time elapsed in nanoseconds from 1 January 1970, at 00:00:00.
LL get_time() {
    return chrono::duration_cast<chrono::nanoseconds>(
        chrono::steady_clock::now().time_since_epoch())
        .count();
}

// Returns a random integer from the range [l, r].
LL randint(LL l, LL r) {
	#if DEBUG && !ONLINE_JUDGE
	static mt19937_64 gen; // Deterministic on the local machine.
	#else
	static mt19937_64 gen(chrono::steady_clock::now().time_since_epoch().count());
	#endif
	return uniform_int_distribution<LL>(l, r)(gen);
}

template <typename Iterator>
string print_iterable(Iterator begin, Iterator end, string bef, string aft,
        function<string(typename iterator_traits<Iterator>::value_type)>* f = nullptr);

template <typename S, typename T>
ostream& operator <<(ostream& out, const pair<S, T>& p);

#define _define_print_container(Container, bef, aft)        \
template <typename T>                                       \
ostream& operator <<(ostream& out, const Container<T>& v) { \
    out << print_iterable(v.begin(), v.end(), bef, aft);    \
    return out;                                             \
}                                                           \

_define_print_container(vector, "[", "]");
_define_print_container(set, "{", "}");
_define_print_container(unordered_set, "{", "}");
_define_print_container(multiset, "{", "}");
_define_print_container(unordered_multiset, "{", "}");
_define_print_container(deque, "[", "]");

#define _define_print_dictionary(Dictionary, bef, aft)                      \
template <typename T1, typename T2>                                         \
ostream& operator <<(ostream& out, const Dictionary<T1, T2>& v) {           \
    out << print_iterable(v.begin(), v.end(), bef, aft);                    \
    return out;                                                             \
}                                                                           \

_define_print_dictionary(map, "{", "}");
_define_print_dictionary(unordered_map, "{", "}");

#define _define_print_container_adaptor(Adaptor, OP)                        \
template <typename T>                                                       \
ostream& operator <<(ostream& out, Adaptor<T> a) {                          \
    vector<T> v;                                                            \
    while (!a.empty()) v.push_back(a.OP()), a.pop();                        \
    out << v;                                                               \
    return out;                                                             \
}                                                                           \

_define_print_container_adaptor(stack, top)
_define_print_container_adaptor(queue, front)
_define_print_container_adaptor(priority_queue, top)

template <typename Iterator>
string print_iterable(Iterator begin, Iterator end, string bef, string aft,
        function<string(typename iterator_traits<Iterator>::value_type)>* f) {
    stringstream res;
    res << bef;
    bool is_first = true;
    for (Iterator it = begin; it != end; ++it) {
        if (!is_first) res << ", ";
        if (f != nullptr) res << (*f)(*it);
        else res << *it;
        is_first = false;
    }
    res << aft;
    return res.str();
}

template <typename S, typename T>
ostream& operator <<(ostream& out, const pair<S, T>& p) {
    out << "{" << p.first << ", " << p.second << "}";
    return out;
}

template<class TH>
void _dbg(const char* name, TH val){
    clog << name << ": " << val << endl;
}
template<class TH, class... TA>
void _dbg(const char* names, TH curr_val, TA... vals) {
    while(*names != ',') clog << *names++;
    clog << ": " << curr_val << ", ";
    _dbg(names+1, vals...);
}

#if DEBUG && !ONLINE_JUDGE
    ifstream input_from_file("input.txt");
    #define cin input_from_file

    #define dbg(...) _dbg(#__VA_ARGS__, __VA_ARGS__)
    #define dbg_arr(x, len) \
    clog << #x << ": " << print_iterable(x, x+len, "[", "]") << endl;
    #define dbg_arr1(x, len) \
    clog << #x << ": " << print_iterable(x+1, x+len+1, "[", "]") << endl;
#else
    #define dbg(...)
    #define dbg_arr(x, len)
    #define dbg_arr1(x, len)
#endif

///////////////////////////////////////////////////////////////////////////
//////////////////// DO NOT TOUCH BEFORE THIS LINE ////////////////////////
///////////////////////////////////////////////////////////////////////////

vector<int> transition(vector<LL> bef, vector<LL> aft, vector<int> dist, LL v) {
    int n = SZ(dist);
    vector<int> new_dist = dist;

    // Compress bef and aft so that inversion <-> intersecting.
    vector<int> ord_bef(n), ord_aft(n);
    for (int i = 0; i < n; i++) ord_bef[i] = ord_aft[i] = i;
    sort(all(ord_bef), [&](int i, int j) {
        return (bef[i] != bef[j]) ? bef[i] < bef[j] : aft[i] > aft[j];
    });
    sort(all(ord_aft), [&](int i, int j) {
        return (aft[i] != aft[j]) ? aft[i] < aft[j] : bef[i] > bef[j] ;
    });

    int it = 0;
    for (int oi: ord_bef) bef[oi] = it++;
    it = 0;
    for (int oi: ord_aft) aft[oi] = it++;

    // Fenwick with minimum.
    vector<int> fen(n, 100);
    auto get_min = [&](int p) {
        int res = 100;
        for (; p >= 0; p = (p&(p+1))-1) res = min(res, fen[p]);
        return res;
    };
    auto set_val = [&](int p, int val) {
        for (; p < n; p |= (p+1)) fen[p] = min(fen[p], val);
    };

    // Considering inversions.
    reverse(all(ord_bef));
    for (int oi: ord_bef) {
        new_dist[oi] = min(new_dist[oi], 1 + get_min(aft[oi]));
        set_val(aft[oi], dist[oi]);
    }

    fill(all(fen), 100);
    reverse(all(ord_aft));
    for (int oi: ord_aft) {
        new_dist[oi] = min(new_dist[oi], 1 + get_min(bef[oi]));
        set_val(bef[oi], dist[oi]);
    }
    return new_dist;
}

struct Segment {
    LL h0, h1;
    int l, r;
    LL h(int x) const { return h0 + (h1-h0)*x; }
};

int main() {
    int n, m;
    LL s, v;
    cin >> n >> m >> s >> v;
    v++;
    LL mul = 8*9*5*7;
    s *= mul, v *= mul;

    typedef pair<LL, LL> pii;
    vector<vector<pii>> trains(m+1);
    for (int i = 0; i < n; i++) {
        LL a, b;
        int r;
        cin >> a >> b >> r;
        a *= mul, b *= mul;
        trains[r].push_back({a, b});
    }
    for (int i = 1; i <= m; i++) sort(all(trains[i]));

    vector<Segment> segments;

    auto get_intersections = [&](LL h0, LL h1) {
        vector<bool> intersecting(m+2, false);
        for (int i = 1; i <= m; i++) {
            LL h = h0 + (h1-h0)*i;
            if (h < 0 or h > s) intersecting[i] = true;
            auto it = upper_bound(all(trains[i]), pair<LL,LL>{h, 1e18});
            if (it == trains[i].begin()) continue;
            const auto& train = *prev(it);
            if (train.first < h and h < train.second) intersecting[i] = true;
        }
        return intersecting;
    };

    auto gen_segment = [&](LL h0, LL h1, int from, int to) {
        if (h1 - h0 < v) return;
        vector<bool> intersecting = get_intersections(h0, h1);
        int l = from, r = from;
        while (!intersecting[l] and l > 0) l--;
        while (!intersecting[r] and r < m+1) r++;
        if (r <= to) return;
        Segment seg{.h0 = h0, .h1 = h1, .l = l, .r = r};
        segments.push_back(seg);
    };

    auto add_segment_max_speed = [&](int x, LL y) {
        LL h0 = y + v*(0-x);
        LL h1 = y + v*(1-x);
        gen_segment(h0, h1, x, x);
    };

    auto add_segment = [&](int x1, LL y1, int x2, LL y2) {
        LL h0 = y1 + ((y2-y1)*(0-x1)) / (x2-x1);
        LL h1 = y1 + ((y2-y1)*(1-x1)) / (x2-x1);
        gen_segment(h0, h1, x1, x2);
    };

    add_segment_max_speed(0, 0);
    for (int i = 1; i <= m; i++) for (auto p1: trains[i]) {
        add_segment_max_speed(i, p1.second);
        for (int j = i+1; j <= m; j++) for (auto p2: trains[j])
            add_segment(i, p1.first, j, p2.second);
    }

    int Q = segments.size();
    vector<int> dist(Q, 100);
    for (int j = 0; j < Q; j++)
        if (segments[j].l == 0 and segments[j].h(0) >= 0) dist[j] = 0;

    for (int i = 1; i <= m; i++) {
        vector<LL> bef;
        vector<LL> aft;
        vector<int> _dist;

        for (int j = 0; j < Q; j++) {
            const auto& seg = segments[j];
            if (!(seg.l <= i-1 and i <= seg.r)) continue;
            _dist.push_back(dist[j]);
            bef.push_back(seg.h(i-1));
            aft.push_back(seg.h(i));
        }
        
        vector<int> new_dist = transition(bef, aft, _dist, v);

        int it = 0;
        for (int j = 0; j < Q; j++) {
            const auto& seg = segments[j];
            if (!(seg.l <= i-1 and i <= seg.r)) continue;
            dist[j] = new_dist[it++];
        }
    }

    int best = 100;
    for (int j = 0; j < Q; j++) {
        if (segments[j].r == m+1 and segments[j].h(m+1) <= s)
            best = min(best, dist[j]);
    }
    if (best >= 100) cout << -1 << "\n";
    else cout << best << "\n";
}
